'Build Version: 3.0.118.0
'***********************************************************************
' THIS CODE AND INFORMATION IS PROVIDED TO YOU FOR YOUR REFERENTIAL 
' PURPOSES ONLY, AND IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
' EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE, 
' AND MAY NOT BE REDISTRIBUTED IN ANY MANNER.
' 
' Copyright (c) 2004  Microsoft Corporation.  All rights reserved.
'***********************************************************************


Sub SAMCreateCustomer()
' **********************************************************
' Function SAMCreateCustomer <none>
' Description: Creates a new customer on a local machine
' In: none
'
' Out: none
' **********************************************************
' Bind to the computer
Set oNewContainer = GetObject("WinNT://" & strServer )
write "Bound to " & oNewContainer.AdsPath, Err_INFO	

Write "Creating Group Accounts.",Err_INFO
' Create the admins Group for the customer
' set the SAM AccountName for the group
' for the WinNT Provider this is also the object name
' make sure it is not longer then 20 Characters and does Not
' start or end with a space (chr(32))
Set oAdminGroup = oNewContainer.Create("group",Left("adm_" & Trim(strCustomer),20))
' Commit the Changes to the SAM
oAdminGroup.SetInfo
Write "Created the " & oAdminGroup.Name & " Group.", Err_INFO

' Create the users Group for the customer
Set oUserGroup = oNewContainer.Create("group",Left("usr_" & Trim(strCustomer),20))
' Commit the Changes to the SAM
oUserGroup.SetInfo
Write "Created the " & oUserGroup.Name & " Group.", Err_INFO

Write "Creating User Accounts.",Err_INFO
' Create the Anonymous Account for the new customer
Set oNewUser = oNewContainer.Create("user",Left("IUSR_" & Trim(strCustomer),20))
' Set the Password
oNewUser.Setpassword strPassword
' Commit the changes to the SAM
oNewUser.SetInfo
Write "Created User " & oNewUser.Adspath,Err_INFO

' Create the UNC Connection User
' to make this work this user must exist on the 
' File Server with the same user name and password
' You must create the user on the File Server manually or add code
' to do so.
Set oNewUser = oNewContainer.Create("user",Left("UNC_" & Trim(strCustomer),20))
' Set the Password
oNewUser.Setpassword strPassword
' Commit the changes to the SAM
oNewUser.SetInfo

Write "Created User " & oNewUser.Adspath,Err_INFO

' removed the create FTP User Part because we are not using it.
' if you want to have another user in addition to the Admin users
' that can use FTP you must create the user account and then create a 
' FTP Virtual Directory that matches the user name.

' ' Create the FTP User for the Customer
' Set oNewUser = oNewContainer.Create("user",Left("FTP_" & Trim(strCustomer),20))
' ' Set the Password
' oNewUser.Setpassword strPassword
' ' Commit the changes to the SAM
' oNewUser.SetInfo
' ' Now add the User to the Users Group
' ' the AddToGroupNT() Function is located in this script
' varResult = AddToGroupAD(oUserGroup, oNewUser)

Write "Created User " & oNewUser.Adspath,Err_INFO
' reformat strAdminSAMName so that is unique and does not contain invalid characters
' remove @ sign if any and relplace with _
strAdminSAMName = Replace(strAdminSAMName,"@","_")
' remove domain suffix(es)
strAdminSAMName = Split(strAdminSAMName,".")(0)
' trim to 20 Characters
strAdminSAMName = Left(strAdminSAMName,20)
' Ensure Uniqueness
' The GetUniqueSamName Function is located in the 
' helperfunctions.vbs script
strAdminSAMName = GetUniqueSamName(strAdminSAMName)
' Create the Admin User for the new customer
Set oNewUser = oNewContainer.Create("user",strAdminSAMName)
' Set the Password for the user
oNewUser.Setpassword strPassword
' Commit the changes to the SAM
oNewUser.SetInfo
' Now add the user to the Admins Group
varResult = AddToGroupNT(oAdminGroup,oNewUser)

Write "Created User " & oNewUser.Adspath,Err_INFO

Write "Done Creating SAM Objects for Customer " & strCustomer,Err_INFO

End Sub

Function AddToGroupNT (oGroup,oUser)
' **********************************************************
' Function AddToGroupNT (oGroup,oUser) 
' Description: Adds a user to a group on a local machine
' 
' In:	oGroup	....	the Group Object the user will be added to.
'		oUser	....	the UserObject to be added to the group.
'		
' Out: 	AddToGroupAD	the result code for the operation
'						usually 0 if successfull or an
'						ADSI, WIN32 Error.
' **********************************************************

' Do a quick Sanity check if the user and the Group are in the same
' OU otherwise do not add the user and return an error.
If oGroup.Parent = oUser.Parent Then
	Write " Adding user " & oUser.Name & " to group " & oGroup.Name, Err_INFO
	oGroup.Add oUser.ADSPath
	' Commit Changes to SAM
	oGroup.SetInfo
	varResult = Err.Number
Else
	varResult = 99
End If
AddToGroupNT = varResult
End Function
